# LearningGit

A repository to teach using Git

Each of the below sections has instructions using all the following:

- Command Line
- VSCode

***Note:*** If you are not comfortable with using a terminal, or command line,
it is recommended that you start with one of the other tools.

Refer to the [Glossary](Glossary.md) for some helpful definitions.

## Motivation

Read [this document](0-Motivation.md) to read about why we're learning about Git.

## What is Git

Read [this document](1-WhatIsGit.md) to learn more about what Git is.

## Why use Git

Read [this document](2-WhyUseGit.md) to learn more about why using Git is a good
idea.

## Git Basics

Read [this document](3-GitBasics.md) to learn some basic Git commands and principles.

## Branches

Read [this document](4-Branches.md) to learn more about what branches are and
why they're useful.

## Merging

Read [this document](5-Merging.md) to learn more about what merging is and what
it is used for.

## Remotes

Read [this document](6-Remotes.md) to learn more about what a remote is and how
to use one.

## GitLab

Read [this document](7-GitLab.md) to learn about GitLab and some of its features.

## Working With Others

Read [this document](8-WorkingWithOthers.md) to learn how you can utilize all
of the above knowledge to work well with others.

-----------

## Exercises

The below are all different exercises you can use to test your Git knowledge.

### Making your first commit

Let's start with the bread and butter of using Git, creating a commit.

- [Exercise 1](Exercises/E1-FirstCommit.md)

### Creating a working branch

Now that you've made commits to your repository, let's make a branch to keep our
next changes separate from others.

- [Exercise 2](Exercises/E2-CreatingABranch.md)

### Merging your WIP branch

Awesome! We've got a branch with our changes on it, but now we need to merge it
back to the main branch.

- [Exercise 3](Exercises/E3-Merging.md)

### Resolving Merge Conflicts

But, what happens when Git doesn't know what to do when you're merging? A merge
conflict that we'll have to resolve manually

- [Exercise 4](Exercises/E4-MergeConflicts.md)

### Working With a Remote

Let's share our work with the rest of the world by using a remote repository.

- [Exercise 5](Exercises/E5-WorkingWithRemotes.md)

### Creating a Merge Request

Sharing your changes is important. We'll use a Merge Request to let others know that
we have changes we'd like to merge into the main branch of the repository.

- [Exercise 6](Exercises/E6-MergeRequests.md)

### Creating an Issue and solving it

Finally, let's put all of this together and go from creating an issue to having
the changes merged into the main branch.

- [Exercise 7](Exercises/E7-ResolvingAnIssue.md)
